/*
MPLAB C32 Delay Routines
By Bernardo Giovanni
http://www.settorezero.com


NOTE: you must define FOSC in main
*/
void DelayMs(unsigned long value);
void DelayUs(unsigned long value);
void DelayS(unsigned long value);


void DelayMs(unsigned long value)
	{
	unsigned int istat; 
	while (value--)
		{
		istat=INTDisableInterrupts(); // actual interrupt value
		OpenCoreTimer(FOSC/2000); // set compare value for core timer at 1mS
		INTRestoreInterrupts(istat); // restore interrupt value
		mCTClearIntFlag(); // reset core timer interrupt flag
		while(!mCTGetIntFlag()); // stay until core timer interrupt fires
		}
	}

void DelayUs(unsigned long value)
	{
	unsigned int istat; 
	while (value--)
		{
		istat=INTDisableInterrupts(); // actual interrupt value
		OpenCoreTimer(FOSC/2000000); // set compare value for core timer at 1uS
		INTRestoreInterrupts(istat); // restore interrupt value
		mCTClearIntFlag(); // reset core timer interrupt flag
		while(!mCTGetIntFlag()); // stay until core timer interrupt fires
		}
	}	
	
void DelayS(unsigned long value)
	{
	unsigned int istat; 
	while (value--)
		{
		istat=INTDisableInterrupts(); // actual interrupt value
		OpenCoreTimer(FOSC/2); // set compare value for core timer at 1S
		INTRestoreInterrupts(istat); // restore interrupt value
		mCTClearIntFlag(); // reset core timer interrupt flag
		while(!mCTGetIntFlag()); // stay until core timer interrupt fires
		}
	}
